package no.rwr.x;
import gnu.gcj.RawData;

public final class Colormap {

    Screen screen;
    int xid;
    
    public static final byte FLAG_SHARED = 1;
    public static final byte FLAG_NOT_SHARED = 2;
    

    public Colormap(Screen screen, int xid) {
	this.screen = screen;
	this.xid = xid;
    }

    public native long allocateColorPixel(XColor color);
    public XColor allocateColor(int r, int g, int b) {
	XColor color = new XColor(r, g, b);
	allocateColorPixel(color);

	return color;
    }

    public native XColor[] getSharedColors();

    public native XColor[] getXColors();

    private XColor[] newXColorArray(int n) {
	XColor[] array = new XColor[n];
	for (int i=0; i<n; i++) array[i] = new XColor();
	return array;
    }

    
}
