package no.rwr.x;
import gnu.gcj.RawData;

/* FUTURE: Maybe split this class into two classes. One for the
   structure XSetWindowAttributes and one for the
   XWindowAttributes. However they should still share this common base
   class.  */

public class WindowAttributes {
    
    

    // FIXME: this is not good.
    public final static long MASK_BUTTON_PRESS   = 1L<<2;
    public final static long MASK_BUTTON_RELEASE = 1L<<3;


    public final static long MASK_EXPOSURE = 1L<<15;

    public WindowAttributes() {
	init(null);
    }

    public WindowAttributes(Window from) {
	initFromWindow(from);
    }


    private native void initFromWindow(Window from);
    private native void init(WindowAttributes copyFrom);
    protected native void finalize();
    
    public Object clone() {
	WindowAttributes attributes = (WindowAttributes) super.clone();
	// In case of an exception before the stucture is copied.
	attributes.in  = 0;
	attributes.out = 0;

	// TBC
	
	attributes.init(this);
	return attributes;
    }

    public native void setBackground(long pixel);
    public native void setBackground(Pixmap pixmap);
    public native void setEventMask(long eventMask);

    public void setVisual(Visual visual) {
	this.visual = visual;
    }

    /**
       @return this visual that is or should be used by a window. null
       means CopyFormParent.
    */
    public native Visual getVisual();

    Display display;

    RawData in = 0;
    RawData out = 0;
    long mask;



    // null: CopyFromParent during window creation
    Visual visual = null;

    public native void apply(Window window);

    final RawData getXSetWindowAttributesStructure() {
	if (out == null) initOut();
	return out;
    }

    void initOut() {
	throw new UnsupportedOperationException("not implemented yet");
    }
}
