package no.rwr.image;

import java.awt.image.Raster;
import java.awt.image.WritableRaster;


/** An interface similar to java.awt.image.RasterOp. I implemented
    this instead og java.awt.image.RasterOp since java.awt.image.RasterOp
    uses RenderingHints, which is something I don't want to tackle yet.

    My RasterOp is currently a subset of the Sun RasterOp.
 */

public interface RasterOp {
    WritableRaster filter(Raster src, WritableRaster dest);

    WritableRaster createCompatibleDestRaster(Raster src);
}
